> For the complete documentation index, see [llms.txt](https://docs.decentraland.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.decentraland.org/contributor/contributor-ko/scene-runtime/runtime-modules/restricted-actions.md).

# 제한된 작업

이 `RestrictedActions` 이 모듈은 씬이 민감한(따라서 제한된) 기능에 접근할 수 있도록 합니다. 이는 다음과 연결되어 있습니다. [`권한`](https://github.com/decentraland/docs/blob/main/contributor/content/entity-types/scenes/README.md#permissions) 시스템이며, 씬은 이를 사용해 개별 메서드의 사용을 요청합니다.

```ts
const RestrictedActions = require("~system/RestrictedActions");
```

{% hint style="info" %}
World Explorer 구현자로서, 런타임에는 권한 적용이 전혀 없을 수도 있습니다. 우리는 **강력히** 이를 권장하지 않습니다. 플레이어를 위험에 빠뜨리기 때문입니다.
{% endhint %}

제한된 기능의 대부분은 이 모듈에서 제공되지만, 또한 제한된 [전역 함수](https://github.com/decentraland/docs/blob/main/contributor/globals/README.md).

이 모듈에는 다음 메서드와 타입이 포함됩니다:

* [`함수 movePlayerTo`](#movePlayerTo)
* [`함수 teleportTo`](#teleportTo)
* [`함수 triggerEmote`](#triggerEmote)
* [`함수 changeRealm`](#changeRealm)
* [`함수 openExternalUrl`](#openExternalUrl)
* [`함수 openNftDialog`](#openNftDialog)
* [`함수 setCommunicationsAdapter`](#setCommunicationsAdapter)
* [`인터페이스 Vector3`](#Vector3)

### 메서드

아래 메서드 각각은 특정 [권한](https://github.com/decentraland/docs/blob/main/contributor/content/entity-types/scenes/README.md#permissions) 에 연결되어 있으며, 씬 매니페스트에서 요청할 수 있습니다.

**`movePlayerTo`**

플레이어를 현재 위치를 기준으로 한 새 위치로 이동시키고, 필요하면 카메라 타겟을 [벡터](#Vector3).

다음 권한이 필요합니다: [`ALLOW_TO_MOVE_PLAYER_INSIDE_SCENE`](https://github.com/decentraland/docs/blob/main/contributor/content/entity-types/scenes/README.md#permissions) 권한.

```ts
interface Request {
  newRelativePosition: Vector3;
  cameraTarget?: Vector3;
}

interface Response {
    // 플레이어가 새 위치로 이동한 뒤, 플레이어가 이동을 중단하지 않았다면 true가 됩니다.
  success: boolean;
}

function movePlayerTo(Request): Promise<Response>;
```

**`teleportTo`**

주어진 절대 월드 위치로 플레이어를 재배치합니다. [벡터](#Vector3).

사전 승인된 권한을 요구하는 대신, 다음에 대한 각 호출은 `teleportTo` 플레이어의 승인을 받아야 합니다.

```ts
interface Request {
  worldPosition: Vector3;
}

interface Response {}

function teleportTo(Request): Promise<Response>;
```

**`triggerEmote`**

미리 정의된 이름 중 하나를 사용해 플레이어의 아바타가 이모트 애니메이션을 표시하도록 합니다.

다음 권한이 필요합니다: [`ALLOW_TO_TRIGGER_AVATAR_EMOTE`](https://github.com/decentraland/docs/blob/main/contributor/content/entity-types/scenes/README.md#permissions) 권한.

```ts
interface Request {
  predefinedEmote: string;
}

interface Response {}

function triggerEmote(Request): Promise<Response>;
```

**`openExternalUrl`**

적절한 UI(다른 애플리케이션일 수도 있음)를 사용해 플레이어에게 웹사이트를 보여줄지 제안합니다.

다음 권한이 필요합니다: [`OPEN_EXTERNAL_LINK`](https://github.com/decentraland/docs/blob/main/contributor/content/entity-types/scenes/README.md#permissions) 권한.

```ts
interface Request {
  url: string;
}

interface Response {
  // 플레이어가 링크 열기를 승인했는지 여부.
  success: boolean;
}

function openExternalUrl(Request): Promise<Response>;
```

**`openNftDialog`**

적절한 UI를 사용해 플레이어에게 NFT에 대한 정보를 표시합니다.

```ts
interface Request {
  // NFT의 URN.
  urn: string;
}

interface Response {
  // NFT를 성공적으로 찾았고 이미지 또는 비디오로 연결되었는지 여부.
  success: boolean;
}

function openNftDialog(Request): Promise<Response>;
```

**`changeRealm`**

기본 URL을 사용해 World Explorer를 다른 콘텐츠 서버로 전환합니다.

```ts
interface Request {
  // 변경을 승인해야 할 때 사용자에게 보여줄 선택적 메시지.
  realm: string;

  // 변경을 승인해야 할 때 사용자에게 보여줄 선택적 메시지.
  message?: string;
}

interface Response {
  // realm 변경이 승인되었고 성공했는지 여부.
  success: boolean;
}

function changeRealm(Request): Promise<Response>;
```

### 타입

이 모듈의 메서드에서 사용하는 유일한 추가 타입은 `Vector3`.

**`Vector3`**

상대적 또는 절대적인 3D 위치를 보유합니다.

```ts
interface Vector3 {
  x: number;
  y: number;
  z: number;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.decentraland.org/contributor/contributor-ko/scene-runtime/runtime-modules/restricted-actions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
